/*
 * This file is part of ArmarX.
 *
 * Copyright (C) 2011-2016, High Performance Humanoid Technologies (H2T), Karlsruhe Institute of Technology (KIT), all rights reserved.
 *
 * ArmarX is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * ArmarX is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * @package
 * @author
 * @date
 * @copyright  http://www.gnu.org/licenses/gpl-2.0.txt
 *             GNU General Public License
 */
#include "VariantItem.h"

#include <ArmarXCore/util/json/JSONObject.h>

namespace armarx
{

    VariantItem::VariantItem(const QString& name, const VariantPtr& value) :
        QStandardItem(name),
        value(value)
    {
        JSONObjectPtr json = new JSONObject();
        auto values = JSONObject::ConvertToBasicVariantMap(json, value);

        for (auto& value : values)
        {
            VariantPtr var = VariantPtr::dynamicCast(value.second);
            QList<QStandardItem*> list;
            auto name = QString::fromStdString(value.first);
            name.remove("value.");

            if (name.contains("typeName"))
            {
                continue;
            }

            list << new QStandardItem(name)
                 << new QStandardItem(QString::fromStdString(var->getOutputValueOnly()));

            appendRow(list);

        }
    }

    int VariantItem::type() const
    {
        return TYPE;
    }

} // namespace armarx


